import muse.apps.run.Run;

public class RunSwapNode {
	public static void main(String[] args)	{
		//prepares the parameters
		Run.Parameters p = new Run.Parameters();
		setData(p);
		setFlags(p);

		//executes the method
		Run r = new Run(p);
		r.run();
	}

	//Environment
	private static final String museHome          = "";
	private static final String sicstusServerHost = "localhost";
    private static final int    sicstusServerPort = 8888;
	private static final String cvc3Path          = museHome + "lib/cvc3/cvc3.exe";
    private static final String jreRtJarPath      = museHome + "data/jre/rt.jar";
    private static final String targetClassPath   = museHome + "bin/";
    private static final String classPath         = jreRtJarPath + ";" + targetClassPath; 
    private static final String sourcePath        = museHome + "examples/list_sorting/src/";
	private static final String substMapFilePath  = museHome + "example/list_sorting/settings/substMap.txt";
	private static final String methodSignature   = "Node:()LNode;:swapNode"; 
	private static final String dumpFilePath      = museHome + "output/list_sorting_dump.txt";

	private static void setData(Run.Parameters p) {
		p.setSicstusServerHost(sicstusServerHost);
		p.setSicstusServerPort(sicstusServerPort);
		p.setCVC3Path(cvc3Path);
		p.setClassPath(classPath);
		p.setSourcePath(sourcePath);
		p.setSubstitutionMapFileName(substMapFilePath);
		p.setMethodSignature(methodSignature);
		p.setOutputFileName(dumpFilePath);
	}
	
	private static void setFlags(Run.Parameters p) {
		//decision procedure
		p.setSimplifierNone();
		
		//show simplifier interaction
		p.setSimplifierShowInteraction();
		
		//show granularity
		p.setTemporalGranularityModeAll();
		
		//step granularity
		p.setStepSource();

		//set interaction mode
		p.setInteractionModeNoInteraction();
	}
}
