/**
 * An example from S. Khurshid, C. S. Pasareanu, and W. Visser, 
 * "Generalized Symbolic Execution for Model Checking and Testing", 
 * in Proceedings of TACAS 2003, fig. 1. 
 * This class is the <code>Node</code> class as found in fig. 1. 
 */
public class Node {
	int elem;
	Node next;

	/* Instrumentation of code for checking the following property:
	 * F (elem =< next.elem or next == null)
	 */
	boolean _AP0; // The value of the current node is less or equal to the value of the next one. 
	boolean _AP1; // The current node is the last one in the list. 
	
	Node swapNode() {
		if (next != null) {
			_AP1 = false;
			if (elem - next.elem > 0) {
				_AP0 = false;
				Node t = next;
				next = t.next;
				t.next = this;
				_AP0 = true;
				return t;
			} else {
				_AP0 = true;
				return this;
			}
		} else {
			_AP1 = true;
			return this;
		}
	}
}