import muse.apps.run.Run;
import muse.jvm.ExecutionObserver;

public class RunLockUnlock {
	public static void main(String[] args)	{
		//prepares the parameters
		Run.Parameters p = new Run.Parameters();
		setData(p);
		setFlags(p);

		//executes the method
		Run r = new Run(p);
		r.run();
	}

	//Environment
	private static final String museHome          = "";
	private static final String sicstusServerHost = "localhost";
    private static final int    sicstusServerPort = 8888;
	private static final String cvc3Path          = museHome + "lib/cvc3/cvc3.exe";
    private static final String jreRtJarPath      = museHome + "data/jre/rt.jar";
    private static final String targetClassPath   = museHome + "bin/";
    private static final String classPath         = jreRtJarPath + ";" + targetClassPath; 
    private static final String targetSourcePath  = museHome + "examples/locking/src/";
    private static final String javaSourcePath    = museHome + "data/jre/src/";
    private static final String sourcePath        = javaSourcePath + ";" + targetSourcePath;
	private static final String methodSignature   = "LockUnlock:(I)V:example"; 
	private static final String dumpFilePath      = museHome + "output/locking_dump.txt";
	private static String[] observedVarNames = {"_ERROR_0", "_ERROR_1"};
	private static ExecutionObserver[] observers = {
		new ExecutionObserver() {
			@Override
			public void update() {
				System.out.println("======= Error 0 reached ======="); 
				this.getEngine().stopCurrentTrace(); 
			}
		}, 
		new ExecutionObserver() { 
			@Override
			public void update() {
				System.out.println("======= Error 1 reached ======="); 
				this.getEngine().stopCurrentTrace(); 
			} 
		} 
	};
	
	private static void setData(Run.Parameters p) {
		p.setSicstusServerHost(sicstusServerHost);
		p.setSicstusServerPort(sicstusServerPort);
		p.setCVC3Path(cvc3Path);
		p.setClassPath(classPath);
		p.setSourcePath(sourcePath);
		p.setMethodSignature(methodSignature);
		p.setOutputFileName(dumpFilePath);
		p.setObservers(observedVarNames, observers);
	}
	
	private static void setFlags(Run.Parameters p) {
		//decision procedure
		p.setSimplifierCVC3();
		
		//show simplifier interaction
		p.setSimplifierDontShowInteraction();
		
		//show granularity
		p.setTemporalGranularityModeNone();
		
		//step granularity
		p.setStepSource();

		//set interaction mode
		p.setInteractionModeNoInteraction();
		
		//set depth scope
		//p.setDepthScope(30);
		p.setDepthScopeUnlimited();

		//set count scope
		//p.setCountScope(1000);
		p.setCountScopeUnlimited();
	}
}
