/** 
 * Demo code for array analysis.
 */ 
public class ArrayDemo {
	boolean any;
	
	//arrays created during the demo
	public int[] a;
	public Object[] b;
	public int[][] c;
	public Object[][][] d;
	public int[] e;
	public int[][] f;
	public int[] g;
	public int[][][] h;

	//outcomes of read operations
	public int retA;
	public Object retB;
	public int retC;
	public Object retD;	
	public int retE_1;
	public RuntimeException retE_2;
	public int retF_1;
	RuntimeException retF_2;
	public int retG_1;
	public RuntimeException retG_2;
	public int retH_1;
	public RuntimeException retH_2;

	private int aM() {
		this.a = new int[3];
		this.a[2] = 55;
		int i = this.a[2];
		return i;
	}

	private Object bM() {
		this.b = new Object[1];
		this.b[0] = new Object();
		Object o = this.b[0];
		return o;
	}

	private int cM() {
		this.c = new int[1][2];
		this.c[0][1] = 42;
		int i = this.c[0][1];
		return i;
	}

	private Object dM() {
		this.d = new Object[1][2][3];
		this.d[0][1][2] = new Object();
		Object o = this.d[0][1][2];
		return o;
	}

	private int eM() {
		this.e = new int[1];
		int i = this.e[4];
		return i;
	}

	private int fM(int x) {
		this.f = new int[3][x];
		return this.f[0][2];
	}

	private int gM(int x) {
		this.g = new int[x];
		return this.g[x - 1];
	}
	
	private int hM(int x) {
		this.h = new int[2][x][3];
		this.h[1][3][1] = 2;
		return this.h[1][3][1];
	}

	public void entryPoint(int x) {
		//initialization
		a = null;
		b = null;
		c = null;
		d = null;
		e = null;
		f = null;
		g = null;
		retA = 0;
		retB = null;
		retC = 0;
		retD = null;
		retE_1 = -77;
		retE_2 = null;
		retF_1 = -1;
		retF_2 = null;
		retG_1 = -1;
		retG_2 = null;
		retH_1 = -1;
		retH_2 = null;

		retA = this.aM();
		retB = this.bM();
		retC = this.cM();
		retD = this.dM();

		try {
			retE_1 = this.eM();
		} catch (RuntimeException ex) {
			retE_2 = ex;
		}

		//we use nondeterminism to reduce the number of path combinations
		//and thus the number of leaf states
		if (any) {
			try {
				retF_1 = this.fM(x);
			} catch (RuntimeException ex) {
				retF_2 = ex;
			}
		} else if (any){
			try {
				retG_1 = this.gM(x);
			} catch (RuntimeException ex) {
				retG_2 = ex;
			}
		} else {
			try {
				retH_1 = this.hM(x);
			} catch (RuntimeException ex) {
				retH_2 = ex;
			}
		}
		
		//At the end of the symbolic execution in all the leaf states Object[0], the root object, has:
		//
		//  a == reference to Object[1] (which is {0, 0, 55}), retA == 55
		//  b == reference to Object[2] (which is  {Object[3]}, where Object[3] has class Object), 
		//     retB == reference to Object[3] (with class Object)
		//  c == reference to Object[4] (which is {Object[5]}, where Object[5] is {0, 42}), retC == 42
		//  d == reference to Object[6] (which is {Object[7]}, where Object[7] is {Object[8], Object[9]}, 
		//     Object[8] is {null, null, null} and Object[9] is {null, null, Object[10]}, and Object[10] 
		//     has class Object), retD == reference to Object[10] 
		//  e == reference to Object[11] (which is {0}), retE_1 == -77, retE_2 == reference to Object[12] 
		//     (with class java.lang.ArrayIndexOutOfBoundsException)
		//
		//Moreover the leaf states should be 6 with the following features:
		//
		//1- the path condition is equivalent to x < 0, f == null, retF_1 == -1, retF_2 == reference 
		//   to Object[13] (with class java.lang.NegativeArraySizeException), g/h, retG_1/H_1 
		//   and retG_2/H_2 have their initial values (null, -1, null respectively)
		//2- the path condition is equivalent to 0 <= x < 3 ->, f == reference to Object[13] 
		//   (which is {Object[14], Object[15], Object[16]}, which in turn are all 
		//   {0 <= INDEX < x -> 0}), retF_1 == -1, retF_2 == reference to Object[17] 
		//   (with class java.lang.ArrayIndexOutOfBoundsException), , g/h, retG_1/H_1 
		//   and retG_2/H_2 have their initial values (null, -1, null respectively)
		//3- the path condition is equivalent to x >= 3, f == reference to Object[13] (which is 
		//   as in leaf state 3), retF_1 == 0, retF_2 == null, , g/h, retG_1/H_1 
		//   and retG_2/H_2 have their initial values (null, -1, null respectively)
		//4- the path condition is equivalent to x < 0, g == null, retG_1 == -1, retG_2 == reference 
		//   to Object[13] (with class java.lang.NegativeArraySizeException), f/h, retF_1/H_1 
		//   and retF_2/H_2 have their initial values (null, -1, null respectively)
		//5- the path condition is equivalent to x == 0, g == reference to Object[13] (which is 
		//   {0 <= INDEX < x -> 0}), retG_1 == -1, retG_2 == reference to Object[14] (with class 
		//   java.lang.ArrayIndexOutOfBoundsException), f/h, retF_1/H_1 
		//   and retF_2/H_2 have their initial values (null, -1, null respectively)
		//6- the path condition is equivalent to x > 0, g == reference to Object[13] (which is 
		//   as in the previous case), retG_1 == 0, retG_2 == null, f/h, retF_1/H_1 
		//   and retF_2/H_2 have their initial values (null, -1, null respectively)
		//7- the path condition is equivalent to x < 0, h == null, retH_1 == -1, retH_2 == 
		//   reference to Object[13] (with class java.lang.NegativeArraySizeException), 
		//   f/g, retF_1/G_1 and retF_2/G_2 have their initial values (null, -1, null respectively)
		//8- the path condition is equivalent to 0 <= x < 4, h == Object[13] (which is 
		//   {Object[14], Object[15]}, which in turn are both {0 <= INDEX < x -> {R<3>}}), 
		//   retH_1 == -1, retH_2 == reference to Object[] (with class 
		//   java.langArrayIndexOutOfBoundsException), f/g, retF_1/G_1 and retF_2/G_2 have 
		//   their initial values (null, -1, null respectively)
		//9- x >= 4 -> h == Object[13], retH_1 == 2, retH2 == null
	}
}
