import muse.apps.run.Run;

public class RunTsafe {
	public static void main(String[] args)	{
		//prepares the parameters
		Run.Parameters p = new Run.Parameters();
		setData(p);
		setFlags(p);

		//executes the method
		Run r = new Run(p);
		r.run();
	}

	//Environment
	private static final String museHome          = "";
	private static final String sicstusServerHost = "localhost";
    private static final int    sicstusServerPort = 8888;
	private static final String cvc3Path          = museHome + "lib/cvc3/cvc3.exe";
    private static final String stubsClassPath    = museHome + "bin/";
    private static final String jreRtJarPath      = museHome + "data/jre/rt.jar";
    private static final String targetClassPath   = museHome + "bin/";
    private static final String classPath         = stubsClassPath + ";" + jreRtJarPath + ";" + targetClassPath; 
    private static final String targetSourcePath  = museHome + "examples/tsafe/src/sliced_2/";
    private static final String stubsSourcePath   = museHome + "examples/tsafe/src/stubs/";
    private static final String javaSourcePath    = museHome + "data/jre/src/";
    private static final String sourcePath        = stubsSourcePath + ";" + javaSourcePath + ";" + targetSourcePath;
	private static final String classInitFilePath = museHome + "examples/tsafe/settings/classInit.txt";
	private static final String substMapFilePath  = museHome + "examples/tsafe/settings/substMap.txt";
	private static final String methodSignature   = "tsafe/engine/TsafeEngine:()V:start"; 
	private static final String dumpFilePath      = museHome + "output/tsafe_dump.txt";

	private static void setData(Run.Parameters p) {
		p.setSicstusServerHost(sicstusServerHost);
		p.setSicstusServerPort(sicstusServerPort);
		p.setCVC3Path(cvc3Path);
		p.setClassPath(classPath);
		p.setSourcePath(sourcePath);
		p.setClassInitFileName(classInitFilePath);
		p.setSubstitutionMapFileName(substMapFilePath);
		p.setMethodSignature(methodSignature);
		p.setOutputFileName(dumpFilePath);
	}
	
	private static void setFlags(Run.Parameters p) {
		//decision procedure
		p.setSimplifierSicstus();
		
		//show simplifier interaction
		p.setSimplifierDontShowInteraction();
		
		//show granularity
		p.setTemporalGranularityModeAll();
		
		//step granularity
		p.setStepSource();

		//set interaction mode
		p.setInteractionModeNoInteraction();
		
		//set heap scope
		p.setHeapScope(40);

		//set depth scope
		p.setDepthScope(30);

		//set count scope
		p.setCountScope(1000);
	}
}
