@REM Runs the model checker. Note that, being the file a batch script, 
@REM should any parameter contain a semicolon it must be encloses in quotes.
@REM For instance:
@REM
@REM    check /p ForG Test/ListSorting/Node:()LTest/ListSorting/Node;:swapNode 
@REM
@REM doesn't work, while:
@REM
@REM    check /p ForG "Test/ListSorting/Node:()LTest/ListSorting/Node;:swapNode"
@REM
@REM does.

@ECHO OFF
SETLOCAL
CALL set_environment
%JAVA% -cp "%PATH_MUSE%;%PATH_JAVASSIST%" muse.apps.mc.Check /Rn %~n0 /cp "%RT_JAR%;%PATH_TARGET%" %1 %2 %3 %4 %5 %6 %7 %8 %9
IF "%1"=="/h" GOTO COMPLETE_HELP
IF "%1"=="/?" GOTO COMPLETE_HELP
GOTO EXIT

:COMPLETE_HELP
REM  12345678901234567890123456789012345678901234567890123456789012345678901234567890
ECHO.
ECHO The check script simplifies the use of the MCEngine.MCEngine class by 
ECHO passing the correct classpath to the java command, and by setting the /cp 
ECHO switch to pass to the symbolic executor the path to the code under analysis
ECHO and the standard Java library.
ECHO.
ECHO Example: we assume that the property classfile is Safe.class and is in the
ECHO current directory, the Sicstus server is listening at port 8888 of server
ECHO 131.151.20.44, the method to be verified is
ECHO.
ECHO   boolean myPackage.MyClass.myMethod(Object o)
ECHO.
ECHO and we want to abort search as the current state's heap size exceeds 500 
ECHO objects. Then, the analysis is run by invoking:
ECHO.
ECHO    check /p Safe /o out.txt /se 131.151.20.44:8888 /sc 500
ECHO        "myPackage/MyClass:(Ljava/lang/Object;)Z:myMethod"
ECHO.
ECHO The path of the model checker, of the Java runtime, of the software under 
ECHO analysis are all set by means of the environment variables in the 
ECHO set_environment script. However, the default value for the /cp switch can 
ECHO be overridden by specifying it on the command line. Note the use of 
ECHO quotes around the method name, as this contains a semicolon.

:EXIT
ENDLOCAL
