package muse.algo;

import muse.bc.ClassFileFactory;
import muse.dec.DecisionProcedure;
import muse.jvm.Environment;
import muse.tree.StateTree;

/**
 * Class containing an <code>Algorithm</code>'s context, i.e., 
 * all it needs to perform its task which differs from the
 * current <code>State</code>.
 * 
 * @author pietro
 */
public class AlgorithmContext {
	Environment env; 
	ClassFileFactory classFileFactory; 
	StateTree stateTree;
	DecisionProcedure decisionProcedure;
	boolean wide;
    
    public AlgorithmContext(Environment env, ClassFileFactory classFileFactory, StateTree stateTree, DecisionProcedure decisionProcedure) {
    	this.env = env;
    	this.classFileFactory = classFileFactory;
    	this.stateTree = stateTree;
    	this.decisionProcedure = decisionProcedure;
    	this.wide = false;
    }
}
