package muse.algo;

import muse.dec.DecisionException;
import muse.mem.Frame;
import muse.mem.Primitive;
import muse.mem.Reference;
import muse.mem.State;

/**
 * Command managing all the *aload (load from array) bytecodes 
 * (aaload, baload, caload, daload, faload, iaload, laload, saload).
 *  
 * @author pietro
 * @author unknown
 */
class SEAload implements Algorithm {
    public void exec(State state, AlgorithmContext ctx) throws DecisionException, CannotManageStateException, PartialReferenceResolutionException {
        Frame frame = state.getStack().currentFrame();
        Primitive index = (Primitive) frame.pop();
        Reference myObjectRef = (Reference) frame.pop();
        if (myObjectRef.isNull()) {
        	//base-level throws NullPointerException 
	    	Reference myExceRef = Util.loadInstance(state, "java/lang/NullPointerException");
			frame.push(myExceRef);
	    	state.doThrow(myExceRef);
	    	return;
        }
        
        StateGeneratorArray g = new StateGeneratorArray(state, ctx.stateTree, ctx.decisionProcedure);
        g.generateStatesAload(myObjectRef, index);
    } 
}
