package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Primitive;
import muse.mem.Reference;
import muse.mem.State;
import muse.mem.Value;

class SEAnd implements Algorithm {
    public void exec(State state, AlgorithmContext ctx) {
        Frame frame = state.getStack().currentFrame();
        Value op1 = frame.pop();
        Value op2 = frame.pop();
        frame.push(((Primitive)op1).andBitwise((Primitive)op2));
        
        try {
			state.incPC();
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
			return;
		}
    }
}
