package muse.algo;

import muse.dec.DecisionException;
import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Primitive;
import muse.mem.Reference;
import muse.mem.State;
import muse.mem.Type;

class SEAnewarray implements Algorithm {
    public void exec(State state, AlgorithmContext ctx) throws DecisionException, CannotManageStateException, PartialReferenceResolutionException {
        Frame frame = state.getStack().currentFrame();
        
    	//determines the array's type
        String arrayType;
        {
	    	int index;
	    	try {
		        byte tmp = state.getInstruction(1);
		        index = Util.byteCat(tmp,state.getInstruction(2));
			} catch (CodeOutOfIndexException e) {
				Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
				frame.push(myExceRef);
				state.doThrow(myExceRef);
				return;
			}
			String currentClassName = frame.getName().getClassName();
			arrayType = "" + Type.ARRAYOF + Type.REFERENCE;
			arrayType += state.getClassFileInterface().getClassFile(currentClassName).getClassSignature(index);
			arrayType += Type.TYPEEND;
        }
        
        //pops the array's length from the operand stack
        Primitive length = (Primitive) frame.pop();
		//TODO length type check

		//generates the next states
		StateGeneratorArray g = new StateGeneratorArray(state, ctx.stateTree, ctx.decisionProcedure);
		g.generateStatesAnew(arrayType, new Primitive[] { length }, 3);
    } 
}