package muse.algo;

import muse.mem.Array;
import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.State;

class SEArrayLength implements Algorithm {
    public void exec(State state, AlgorithmContext ctx) {
        Frame frame = state.getStack().currentFrame();
        Reference tmpRef = (Reference)frame.pop();
        if (tmpRef.isNull()) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/NullPointerException");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
			return;
        }
        
        Array tmpArray = (Array) state.getHeap().getObject(tmpRef);
        frame.push(tmpArray.getLength());

        try {
			state.incPC();
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
		}
    } 
}
