package muse.algo;

import muse.dec.DecisionException;
import muse.mem.Frame;
import muse.mem.Primitive;
import muse.mem.Reference;
import muse.mem.State;
import muse.mem.Value;

class SEAstore implements Algorithm {
    public void exec(State state, AlgorithmContext ctx) throws DecisionException, CannotManageStateException, PartialReferenceResolutionException {
        Frame frame = state.getStack().currentFrame();
        Value value = frame.pop();
        Primitive index = (Primitive) frame.pop();
        Reference myObjectRef = (Reference)frame.pop();
        if (myObjectRef.isNull()) {
        	//base-level throws NullPointerException 
	    	Reference myExceRef = Util.loadInstance(state, "java/lang/NullPointerException");
			frame.push(myExceRef);
	    	state.doThrow(myExceRef);
	    	return;
        }
        
        StateGeneratorArray g = new StateGeneratorArray(state, ctx.stateTree, ctx.decisionProcedure);
        g.generateStatesAstore(myObjectRef, index, value);
    } 
}
