package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.Simplex;
import muse.mem.State;
import muse.mem.Type;
import muse.mem.Value;

class SEConst implements Algorithm {
    int type;
    int val;
    
    //INTERIM
    public SEConst() { }
    
    public SEConst(int constType,int param) {
        type=constType;
        val=param;
    }
    
    public void exec(State state, AlgorithmContext ctx) throws InvalidTypeException {
        Frame frame = state.getStack().currentFrame();
        if (type == Type.INT) {
            frame.push((Value)new Simplex(val));
        } else if (type == Type.DOUBLE) {
            frame.push((Value)new Simplex((double)val));
        } else if (type == Type.FLOAT) {
            frame.push((Value)new Simplex((float)val));
        } else if (type == Type.LONG) {
            frame.push((Value)new Simplex((long)val));
        } else {
            throw new InvalidTypeException();
        }

        try {
			state.incPC();
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
		}
    } 
}