package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.State;

class SEGoto implements Algorithm {
	/** <code>true</code> for goto, <code>false</code> for goto_w. */
	boolean def;

	//INTERIM
	public SEGoto() {}
	/**
	 * Constructor. 
	 */
	public SEGoto(boolean def) {
		this.def = def;
	}
	
	/**
	 *Implements the true symbolic execution algorithm
	 */
	public void exec(State state, AlgorithmContext ctx) {
		try {
			byte tmp0 = state.getInstruction(1);
			byte tmp1 = state.getInstruction(2);
			if (def) {
				state.incPC(Util.byteCatShort(tmp0, tmp1));
			} else {
				byte tmp2 = state.getInstruction(3);
				byte tmp3 = state.getInstruction(4);
				state.incPC(Util.byteCat(tmp0, tmp1, tmp2, tmp3));
			}
		} catch (CodeOutOfIndexException e) {
			Frame frame = state.getStack().currentFrame();
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
		}
	}
}
