package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Primitive;
import muse.mem.Reference;
import muse.mem.State;
import muse.mem.Value;

class SEIUshr implements Algorithm {
	public void exec(State state, AlgorithmContext ctx) {
		Frame frame = state.getStack().currentFrame();
		try {
			state.incPC();
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
			return;
		}
		Value op2 = frame.pop();
		Value op1 = frame.pop();
		frame.push(((Primitive)op1).ushr((Primitive)op2));
	}
}
