package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.State;
import muse.mem.Type;

class SEIfacmp implements Algorithm {
    boolean eq;

    //INTERIM
    public SEIfacmp() { }
    /**
     * Constructor.
     */
    public SEIfacmp(boolean eq) {
        this.eq = eq;
    }
    
    /**
     * Implements the true symbolic execution algorithm
     */
    public void exec(State state, AlgorithmContext ctx) {
        //devo aggiungere la path condition
        Frame frame = state.getStack().currentFrame();
        
        //determines branch target
        int index;
        try {
	        byte tmp1 = state.getInstruction(1);
	        byte tmp2 = state.getInstruction(2);
	        index = Util.byteCatShort(tmp1, tmp2);
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
			return;
		}
        
        //takes operands from current frame's operand stack;        
        //note that both values are initialized as they come
		//from the operand stack
        Reference val2 = (Reference) frame.pop();
        Reference val1 = (Reference) frame.pop();
        
        //computes branch condition

        boolean valCmp = false;
        
        if (val1.getType() != val2.getType()) {
            valCmp = false; //different when not of the same type
        } else if (val1.getType() == Type.NULLREF) {
            valCmp = true;  //same when both null
        } else { //comparable as both initialized 
            valCmp = val1.equals(val2);
        }
        
        if (eq) {
            ;
        } else {
            valCmp = ! valCmp;
        }

        //performs branch if it is the case
        try {
        	if (valCmp) {
        		state.incPC(index);
        	} else {
        		state.incPC(3);
        	}
        } catch (CodeOutOfIndexException e) {
        	Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
        	frame.push(myExceRef);
        	state.doThrow(myExceRef);
        }
    }
}