package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.State;

class SEIfnull implements Algorithm {
	/** <code>true</code> if the jump is on <code>null</code>, <code>false</code> if jump is on non null. */ 
	boolean def;

	//INTERIM
	public SEIfnull() { }
	/**
	 * Constructor.
	 * @param def <code>true</code> if the jump is on <code>null</code>, 
	 *        <code>false</code> if jump is on non null
	 */
	public SEIfnull(boolean def) {
		this.def = def;
	}

	/**
	 *Implements the true symbolic execution algorithm
	 */
	public void exec(State state, AlgorithmContext ctx) {
		Frame frame = state.getStack().currentFrame();

		try {
			//gets the offset
			byte tmp1 = state.getInstruction(1);
			byte tmp2 = state.getInstruction(2);
			int index = Util.byteCatShort(tmp1,tmp2);
			
			//pops the reference from the operand stack 
			//and calculates the branch condition
			Reference val1 = (Reference) frame.pop();
			boolean valRet = (this.def ? val1.isNull() : (!val1.isNull()));

			//updates the program counter
			if (valRet) {
				state.incPC(index);
			} else {
				state.incPC(3);
			}
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
		}
	}
}