package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.LocalVariablesArea;
import muse.mem.Primitive;
import muse.mem.Reference;
import muse.mem.Simplex;
import muse.mem.State;
import muse.mem.Value;

class SEIinc implements Algorithm {
	public void exec(State state, AlgorithmContext ctx) {
		boolean wide = ctx.wide;
		ctx.wide = false;
		Frame frame = state.getStack().currentFrame();
		
		int index;
		int cons;
		int offset;
		try {
			if (wide) {
				byte tmp1, tmp2, tmp3, tmp4;
				tmp1 = state.getInstruction(1);
				tmp2 = state.getInstruction(2);
				tmp3 = state.getInstruction(3);
				tmp4 = state.getInstruction(4);
				index = Util.byteCat(tmp1, tmp2);
				cons = Util.byteCat(tmp3, tmp4);
				offset = 5;
			} else {
				index = state.getInstruction(1);
				cons = state.getInstruction(2);
				offset = 3;
			}
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
			return;
		}
		
		LocalVariablesArea myLvse = frame.getLocalVariableTable();
		Value tmpVal = myLvse.get(index);
		Simplex constValue = new Simplex(cons);
		myLvse.set(index, ((Primitive)tmpVal).add((Primitive)constValue));
		
		try {
			state.incPC(offset);
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
		}
	}
}
