package muse.algo;

import muse.dec.DecisionException;
import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.State;
import muse.mem.Value;

class SEMonitor implements Algorithm {
	public void exec(State state, AlgorithmContext ctx) throws DecisionException {
        Frame frame = state.getStack().currentFrame();

		//pops its operand and checks it
		Value v = frame.pop();
		if (!(v instanceof Reference)) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
			return;
		}
		Reference r = (Reference) v;
		if (r.isNull()) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/NullPointerException");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
			return;
		}
		
		//TODO we are currently assuming only one thread, so there is nothing else to do

		try {
			state.incPC();
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
		}
	}
}
