package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Primitive;
import muse.mem.Reference;
import muse.mem.State;
import muse.mem.Value;

class SEMul implements Algorithm {
	public void exec(State state, AlgorithmContext ctx) {
		Frame frame = state.getStack().currentFrame();
		Value op0 = frame.pop();
		Value op1 = frame.pop();
		frame.push(((Primitive)op0).mul((Primitive)op1));

		try {
			state.incPC();
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
		}
	}
}
