package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.Simplex;
import muse.mem.State;
import muse.mem.Type;
import muse.mem.Value;

class SEN2n implements Algorithm {
	char type;
	char castType;

	public SEN2n() { }
	
	public SEN2n(char originalType, char castedType) {
		type = originalType;
		castType = castedType;
	}
	public void exec(State state, AlgorithmContext ctx) throws InvalidTypeException {
		Frame frame = state.getStack().currentFrame();
		
		Value value = frame.pop();
		if (value instanceof Simplex) {
			Object obj = ((Simplex)value).getActualValue();
			if (type == Type.INT){
				int val=((Number)obj).intValue();
				if (castType==Type.BYTE)
					frame.push((Value)new Simplex((byte)val));
				else if (castType==Type.CHAR)
					frame.push((Value)new Simplex((char)val));
				else if (castType==Type.DOUBLE)
					frame.push((Value)new Simplex((double)val));
				else if (castType==Type.FLOAT)
					frame.push((Value)new Simplex((float)val));
				else if (castType==Type.LONG)
					frame.push((Value)new Simplex((long)val));
				else if (castType==Type.SHORT)
					frame.push((Value)new Simplex((short)val));
			} else if (type==Type.DOUBLE) {
				double val=((Number)obj).doubleValue();
				if (castType==Type.FLOAT)
					frame.push((Value)new Simplex((float)val));
				else if (castType==Type.INT)
					frame.push((Value)new Simplex((int)val));
				else if (castType==Type.LONG)
					frame.push((Value)new Simplex((long)val));
			} else if(type==Type.FLOAT){
				float val=((Float)obj).floatValue();
				if(castType==Type.DOUBLE)
					frame.push((Value)new Simplex((double)val));
				else if(castType==Type.INT)
					frame.push((Value)new Simplex((int)val));
				else if(castType==Type.LONG)
					frame.push((Value)new Simplex((long)val));
			} else if(type==Type.LONG){
				long val=((Number)obj).longValue();
				if(castType==Type.DOUBLE)
					frame.push((Value)new Simplex((double)val));
				else if(castType==Type.INT)
					frame.push((Value)new Simplex((int)val));
				else if(castType==Type.FLOAT)
					frame.push((Value)new Simplex((float)val));
			} else
				throw (new InvalidTypeException("sbagliato!"));
		} else if(value instanceof Reference)
			throw (new InvalidTypeException("sbagliato!"));
		else {
			value.setType(castType);
			frame.push(value);
		}

		try {
			state.incPC();
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
		}
	} 
}