package muse.algo;

import muse.dec.DecisionException;
import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.State;

class SENew implements Algorithm {
	public void exec(State state, AlgorithmContext ctx) throws DecisionException {
		Frame frame = state.getStack().currentFrame();
		int index;
		try {
			byte tmp1 = state.getInstruction(1);
			byte tmp2 = state.getInstruction(2);
			index = Util.byteCat(tmp1,tmp2);
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
			return;
		}
		String classToOpen = frame.getName().getClassName();

		//initializes the class in case it is not
        if (!state.initialized(classToOpen)) {
        	ClassInitializer.initializeClass(state, classToOpen, ctx.decisionProcedure);
        	return;
        	//now the execution continues with the class 
        	//initialization code; the current bytecode will 
        	//be reexecuted after that
        }

        //creates the new object in the heap
        frame.push(Util.loadInstance(state, state.getClassFileInterface().getClassFile(classToOpen).getClassSignature(index)));
        
		try {
			state.incPC(3);
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
			return;
		}
	} 
}