package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.State;

class SENop implements Algorithm {
	int size;

	public SENop() { size = 1; }

	public void exec(State state, AlgorithmContext ctx) {
        Frame frame = state.getStack().currentFrame();
		try {
			state.incPC(this.size);
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
		}
	} 
}