package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.State;
import muse.mem.Type;
import muse.mem.Value;

class SEPop implements Algorithm {
	/** <code>true</code> for pop, <code>false</code> for pop2 */ 
	boolean def;

	//INTERIM
	public SEPop() { }
	/**
	 * Constructor.
	 * @param def <code>true</code> for pop, <code>false</code> for pop2 
	 */
	public SEPop(boolean single) {
		def = single;
	}
	
	/**
	 * Implements the true symbolic execution algorithm
	 */
	public void exec(State state, AlgorithmContext ctx) {
		Frame frame = state.getStack().currentFrame();

		Value tmp = frame.pop();
		if (def && !Type.isCat_1(tmp.getType())) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
			return;
		}
		
		if (!def && Type.isCat_1(tmp.getType())) {
			tmp = frame.pop();
			if (!Type.isCat_1(tmp.getType())) {
				Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
				frame.push(myExceRef);
				state.doThrow(myExceRef);
				return;
			}
		}
		
		try {
			state.incPC();
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
		}
	}
}
