package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.Simplex;
import muse.mem.State;

class SERet implements Algorithm {
	public void exec(State state, AlgorithmContext ctx) {
		boolean wide = ctx.wide;
		ctx.wide = false;
		
		Frame frame = state.getStack().currentFrame();	
		try {
			int index;
			byte tmp1 = state.getInstruction(1);
			if (wide) {
				byte tmp2 = state.getInstruction(2);
				index = Util.byteCat(tmp1, tmp2);
			} else {
				index = tmp1;
			}
			Simplex ret = (Simplex)(frame.getLocalVariableTable().get(index));
			state.setPC(((Integer)ret.getActualValue()).intValue());
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
			return;
		}
	} 
}
