package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.Simplex;
import muse.mem.State;
import muse.mem.Value;

class SESipush implements Algorithm {
	/**
	 * Implements the true algorithm
	 */
	public void exec(State state, AlgorithmContext ctx) {
		Frame frame = state.getStack().currentFrame();
		try {
			byte tmp0 = state.getInstruction(1);
			byte tmp1 = state.getInstruction(2);
			frame.push((Value) new Simplex((int) Util.byteCatShort(tmp0, tmp1)));
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
			return;
		}

		try {
			state.incPC(3);
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
		}
	}
}
