package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.State;
import muse.mem.Value;

class SEStore implements Algorithm {
	boolean def;
	int index;

	public SEStore() {
		this.def = false;
	}

	public SEStore(int param) {
		this.def = true;
		this.index = param;
	}

	public void exec(State state, AlgorithmContext ctx) {
		boolean wide = ctx.wide;
		ctx.wide = false;
		
		Frame frame = state.getStack().currentFrame();
		Value valTemp = frame.pop();
		try {
			if (!def) {
				if (wide) {
					byte tmp1 = state.getInstruction(1);
					byte tmp2 = state.getInstruction(2);
					this.index = Util.byteCat(tmp1, tmp2);
				} else {
					this.index = state.getInstruction(1);
				}
			}
			frame.getLocalVariableTable().set(this.index, valTemp);
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
			return;
		}

		try {
			if (def) {
				state.incPC();
			} else if (wide) {
				state.incPC(3);
			} else {
				state.incPC(2);
			}
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
		}
	} 
}
