package muse.algo;

import muse.mem.CodeOutOfIndexException;
import muse.mem.Frame;
import muse.mem.Reference;
import muse.mem.State;
import muse.mem.Value;

class SESwap implements Algorithm {
	public void exec(State state, AlgorithmContext ctx) {
		Frame frame = state.getStack().currentFrame();
		Value tmp2 = frame.pop();
		Value tmp1 = frame.pop();
		frame.push(tmp2);
		frame.push(tmp1);
		try {
			state.incPC();
		} catch (CodeOutOfIndexException e) {
			Reference myExceRef = Util.loadInstance(state, "java/lang/VerifyError");
			frame.push(myExceRef);
			state.doThrow(myExceRef);
		}
	}

}
