package muse.apps;

import muse.mem.State;

public abstract class StateFormatterTextTrace implements StateFormatter {
	private final String lineSep = System.getProperty("line.separator");
	private final String fieldSep = " ";

	protected String formatOutput;

	public void format(State s) {
		this.formatOutput = "";
        if (!s.isStuck()) {
        	this.formatOutput += s.getStack().currentFrame().getName() + fieldSep + s.getStack().currentFrame().getSourceRow() + fieldSep + s.getPC() + lineSep;
        }
	}
	
	/**
	 * Must be invoked at the end of a <code>emit()</code> implementation.
	 */
	protected void cleanup() {
		this.formatOutput = "";
	}
}
