package muse.apps.mc;

import java.util.*;

/** Class Rule contains one rule that consists of the condition
 *  and the name of the next state.
 */ 
public class Rule {

public Condition condition;
public StateName nextState;

/** Create a new state with a given name.
 */
public Rule(Condition c, StateName s) {
    condition = c;
    nextState = s;
}

/** Put all atomic propositions to HashSet propositions.
 * 
 * @param propositions
 */
public void getAtomicPropositions(HashSet<String> propositions) {
	condition.getAtomicPropositions(propositions);
	return;
}


/**
 * Evaluate the condition of the rule and if it is evaluated as true
 * add the state into the new states. Return true if the added state
 * is accept_all state.
 */
public boolean doStep(Binding binds, HashSet<StateName> newStates){
    boolean status = false;
    if ( condition.evaluate(binds) ) {
        newStates.add(nextState);
        status = nextState.isAcceptAll();
    }
    return status;
}

/** Own view. */
public String toString() {
    return "( "+condition.toString()+" ) -> "+nextState.toString();
}
} // Rule
