package muse.apps.mc;

/** Class StateName represent the name of the state and consists
 *  of two parts - pre and post. We use it for identifying states
 *  and for deciding wheather the state is initial, accepting
 *  or always accepting.
 */ 
public class StateName {

public String pre;
public String post;

/** Constructor assigns pointers only - does not copy the strings. */
public StateName(String pres, String posts) {
    pre = pres;
    post = posts;
}

/** Return true if the state with this state name is the initial state. */
public boolean isInit() {
    return ( post.equals("init") );
}

/** Return true if the state with this state name is the accepting state. */
public boolean isAccept() {
    return ( pre.equals("accept"));
}

/** Return true if the state with this state name is the always accepting state. */
public boolean isAcceptAll() {
    return ( pre.equals("accept") && post.equals("all"));
}

/** Return string representation of the state name. */
public String toString() {
    return pre+"_"+post;
}

public boolean equals(Object obj) {
    if (!(obj instanceof StateName))
        return false;
    else
        return pre.equals(((StateName)obj).pre) && post.equals(((StateName)obj).post);
}

} // StateName
