package muse.bc;

import muse.jvm.Environment;

import javassist.ClassPool;
import javassist.NotFoundException;

public class ClassFileFactoryJavassist extends ClassFileFactory {
	private ClassPool cpool; 

	public ClassFileFactoryJavassist() { }

	@Override
	public void setEnv(Environment env) {
		this.cpool = new ClassPool();
		for (String s : env.classPath())
			try {
				this.cpool.appendClassPath(s);
			} catch (NotFoundException e) {
				//does nothing
			}
	}
	
	@Override
	protected ClassFile newClassFileClass(String className) {
		return new ClassFileJavassist(className, this.cpool);
	}
}
