package muse.bc;

import java.util.ArrayList;

/**
 * Class that represent an exception table.
 */
public class ExceptionTable {
	private ArrayList<ExceptionTableEntry> exTable;

	/**
	 *Constructor, Initialize the structure that will contain the exception table
	 *@param length number of element of exception table
	 */		
	public ExceptionTable(int length) {	
		exTable = new ArrayList<ExceptionTableEntry>(length);
	}
	
	/**
	 *Returns the number of element of the exception table
	 *@return int the number of element of the exception table
	 */
	public int getLength() {
		return exTable.size();
	}
	
	/**
	 *Given an index of exception table, returns an entry
	 *@return SEExceptionTableEntry an entry in the exception table
	 */
	public ExceptionTableEntry getEntry(int index) {
		return exTable.get(index);
	}
	
	/**
	 *Set an entry of the exception table.
	 *@param index The position where insert the entry
	 *@param entry The entry to insert
	 */
	public void addEntry(ExceptionTableEntry entry) {
		exTable.add(entry);
	}
	
}
