package muse.bc;

/**
 * Class that represents the signature of a method or a field.
 */
public class Signature {
    private String containerClass;
    private String descriptor;
    private String name;
    
    /**
     * Constructor; given the class, the descriptor and the name of a 
     * method or field creates a signature for it.
     * 
     * @param containerClass The name of the class containing the method or field.
     * @param descriptor The descriptor of the method or field.
     * @param name The name of the method or field.
     */	
    public Signature(String containerClass, String descriptor, String name) {
        this.containerClass = containerClass;
        this.descriptor = descriptor;
        this.name = name;
    }
    
    /**
     * Set the Class name
     * @param containerClass the name of class containing the 
     * 
     */
    public void setClassName(String containerClass) {
        this.containerClass=containerClass;
    }
    /**
     *Return the name of the class 
     *@return String the name of the class
     */
    public String getClassName() {
        return this.containerClass;
    }
    
    /**
     *Return the descriptor
     *@return String The descriptor returned
     */
    public String getDescriptor() {
        return this.descriptor;
    }
    
    /**
     *Return the name
     *@return String The name returned
     */
    public String getName() {
        return this.name;
    }
    
    public String toString() {
        return this.containerClass + ":" + this.descriptor + ":" + this.name;
    }
    
    @Override
    public boolean equals(Object o) {
    	if (!(o instanceof Signature))
    		return false;
    	return (this.toString().equals(o.toString()));
    }
}
