package muse.mem;

import java.util.Map;

/**
 * Value representing a string from the constant pool. This kind of 
 * values live only outside the <code>State</code>'s memory and must 
 * be converted into suitable <code>Instance</code>s.
 * 
 * @author pietro
 *
 */
public class ConstantPoolString extends Value {
	String value;
	
	public ConstantPoolString(String value) { this.value = value; }

	@Override
	public boolean equals(Object o) {
		if (!(o instanceof ConstantPoolString)) return false;
		return this.value.equals(((ConstantPoolString) o).value);
	}

	@Override
	public Object getValueForNative() throws ValueDoesNotSupportNativeException {
		throw new ValueDoesNotSupportNativeException();
	}

	@Override
	public void refine(Map<String, ReferenceSymbolic> refs) {
		return; //does nothing
	}

	@Override
	public String toString() {
		return this.value;
	}
}
