package muse.mem;

/**
 * Class that represent the null concrete reference; it is a Singleton
 */
public class Null extends ReferenceConcrete {
    private static Null instance = new Null();
    
    /**
     * Constructor.
     */
    private Null() {
    	super(-99); //the actual value doesn't mind, we chose -99 because it will raise an exception if used to access the Heap
        this.setType(Type.NULLREF);
    }

    public static Null getInstance() {
        return instance;
    }
    
    /**
     * Returns the value
     */
    public String getValue() {
	    return("null");
    }

    @Override
    public boolean isNull() {
        return true;
    }
 
    /**
     * returns String representation of Value
     */
    @Override
    public String toString() {
        return getValue();
    }    
    
    @Override
    public boolean equals(Object o) {
        return (o == this);
    }
}