package muse.mem;

/**
 * Class that contain costants for operators.
 */
public final class Operator
{
	//OPERATORS IMPLEMENTED BY JAVA BYTECODES

	/** Arithmetic sum */
    public static final String ADD  = "+";
    
	/** Arithmetic subtraction */
    public static final String SUB  = "-";

	/** Arithmetic multiplication */
    public static final String MUL  = "*";

	/** Arithmetic division */
    public static final String DIV  = "/";

    /** Arithmetic remainder */
    public static final String REM  = "%";

    /** Arithmetic negation */
    public static final String NEG  = "~";
    
    /** Shift left */
    public static final String SHL  = "<<";

    /** Arithmetic shift right */
    public static final String SHR  = ">>";

    /** Logical shift right */
    public static final String USHR = ">>>";
    
    /** Bitwise OR */
    public static final String ORBW  = "|";
    
    /** Bitwise AND */
    public static final String ANDBW  = "&";
    
    /** Bitwise XOR */
    public static final String XOR  = "^";
    
    /** Arithmetic comparison (greater or equal) */
    public static final String GE   = ">=";
    
	//OPERATORS ADDED FOR SYMBOLIC REASONING
	
    /** Logical and */
    public static final String AND  = "&&";

    /** Logical or */
    public static final String OR   = "||";

    /** Logical not */
    public static final String NOT  = "!";

    /** Inequality */
    public static final String NE   = "!=";

    /** Equality */
    public static final String EQ   = "==";

    /** Arithmetic comparison (less or equal) */
    public static final String LE   = "<=";

    /** Arithmetic comparison (greater) */
    public static final String GT   = ">";

    /** Arithmetic comparison (less) */
    public static final String LT   = "<";

    //NATIVE JAVA PURE METHODS THAT CAN BE INTERPRETED BY SICSTUS 
    public static final String ABS = "abs";
    public static final String SIN = "sin";
    public static final String COS = "cos";
    public static final String TAN = "tan";
    public static final String POW = "pow";
	//public static final String EXP = "exp";
    public static final String MIN = "min";
    public static final String MAX = "max";
    
}