package muse.mem;

/**
 * Class that represent a reference to the heap (both concrete and 
 * symbolic, except null).
 */
public abstract class Reference extends Value {
    /**
     * Constructor.
     */
    public Reference() {
        this.setType(Type.REFERENCE);
    }

	@Override
	public Object getValueForNative() throws ValueDoesNotSupportNativeException {
		throw new ValueDoesNotSupportNativeException();
	}

    public abstract boolean isSymbolic();

    public abstract boolean isNull();
    
    public abstract int getHeapPosition(); //TODO should throw an exception for references which do not indicate a precise heap position
    
    @Override
    public Reference clone() {
    	return (Reference) super.clone();
    }
}