package muse.mem;

import java.util.Map;

public class ReferenceConcrete extends Reference {
	/** The heap position of the referenced object. */
	int value;
	
    /**
     * Constructor returning a concrete reference to an object.
     * 
     * @param ref position of the object in the heap.
     */
    public ReferenceConcrete(int ref) {
    	this.value = ref;
    }

    @Override
    public boolean isSymbolic() {
    	return false;
    }

    @Override
    public String toString() {
        return("Object[" + this.value + "]");
    }
    
    @Override
    public boolean equals(Object o) {
        boolean retVal = false;
        
        if (o instanceof ReferenceConcrete) {
            ReferenceConcrete r = (ReferenceConcrete) o;
            
          	retVal = (this.value == r.value);
        }
        return retVal;
    }

	@Override
	public ReferenceConcrete clone() {
		return (ReferenceConcrete) super.clone();
	}

	@Override
	public void refine(Map<String, ReferenceSymbolic> refs) {
		return; //does nothing
	}

	@Override
	public boolean isNull() {
		return false;
	}

	@Override
	public int getHeapPosition() {
		return this.value;
	}
}
