package muse.mem;

import java.io.IOException;
import java.util.Map;

import muse.dec.DecisionExternalProtocolException;


public class Term extends Primitive {
	String value;
	
	public Term(char type, String value) {
		this.value = value;
		this.setType(type);
	}

	@Override
	public void accept(ExpressionVisitor v) throws IOException,
			DecisionExternalProtocolException {
		v.visitTerm(this);
	}

	@Override
	public String toString() {
		return this.value;
	}

	@Override
	public boolean equals(Object o) {
		if (o instanceof Term) {
			return this.value.equals(((Term) o).value);
		} else {
			return false;
		}
	}

	@Override
	public Object getValueForNative() throws ValueDoesNotSupportNativeException {
		throw new ValueDoesNotSupportNativeException();
	}

	@Override
	public void refine(Map<String, ReferenceSymbolic> refs) {
		return;
	}
}
