package muse.tree;

import muse.mem.Expression;
import muse.mem.Value;

public class DecisionAlternativeAloadValue extends DecisionAlternativeAload {
	/** The value extracted from the array. */
	public Value val;
	
	/** 
	 * <code>true</code> iff <code>this.val</code> is fresh, i.e., it 
	 * was not taken from the array but has been created during the 
	 * decision phase. Such values must be written in the array
	 * during the refinement phase. 
	 */
	public boolean fresh;

	public DecisionAlternativeAloadValue(Expression exp, Value val, boolean fresh) {
		super(exp);
		this.val = val;
		this.fresh = fresh;
	}

	@Override
	public void accept(DecisionAlternativeAloadVisitor v) throws Throwable {
		v.visitDecisionAlternativeAloadValue(this);
	}
}
