package muse.tree;

public class DecisionAlternativeSwitch {
	private int value;
	private static DecisionAlternativeSwitch def = null;
	
	public DecisionAlternativeSwitch(int value) { 
		this.value = value;
	}

	public static DecisionAlternativeSwitch alternativeDefault() {
		if (def == null) {
			def = new DecisionAlternativeSwitch(0);
		}
		return def;
	}
	
	public boolean isDefault() {
		return (this == def);
	}
	
	public int value() {
		return this.value;
	}
	
	@Override
	public boolean equals(Object o) {
		DecisionAlternativeSwitch oo;
		if (o instanceof DecisionAlternativeSwitch) {
			oo = (DecisionAlternativeSwitch) o;
		} else {
			return false;
		}
		return (this == def && oo == def) ||
		       (this != def && oo != def && this.value == oo.value);
	}
}
