package util;

import muse.algo.CannotManageStateException;
import muse.algo.PartialReferenceResolutionException;
import muse.bc.ClassFileFactory;
import muse.bc.ClassFileFactoryJavassist;
import muse.dec.DecisionInitException;
import muse.dec.DecisionProcedure;
import muse.dec.DecisionProcedureAlwSat;
import muse.dec.DecisionRunningException;
import muse.jvm.*;
import muse.mem.*;

public class Util
{

	public static final String museHome = "";
	public static final String jreRtJarPath = museHome + "data/jre/rt.jar";
	public static final String targetClassPath1 = museHome + "bin/";
	public static final String targetClassPath2 = museHome + "jasmin_files.jar"; //as emitted by Jasclipse

	public static State s;
	public static Engine engine;
	public static String path;

	public static void setUp() 
	{
		DecisionProcedure dp = new DecisionProcedureAlwSat();
		ClassFileFactory cff = new ClassFileFactoryJavassist();

		engine = new Engine(cff, dp);
		String classPath[] = new String[3];
		classPath[0] = jreRtJarPath;
		classPath[1] = targetClassPath1;
		classPath[2] = targetClassPath2;
		engine.addClassPath(classPath);
	}


	public static void begin(String params,String method) throws DecisionInitException, InitializationException, NonexistingObservedVariablesException 
	{
		engine.setMethodName(path, params, method);
		engine.init();
	}

	public static void stepUntil(byte code) throws DecisionRunningException, EngineStuckException, CannotManageStateException, PartialReferenceResolutionException
	{
		s = engine.getCurrentState();
		while(engine.canStep() && s.getInstruction() != code)
		{
			engine.step();
			s = engine.getCurrentState();
		}
	} 
}
